-- Section 4.2
-- Expressions with Declarations

type Val = Int
type Env = Assoc Ide Val

expval :: Expr -> Env -> Val
expval (Num n) r = numval n
expval (Var x) r = lookup r x
expval (Bexpr o e e') r = binopr o (expval e r) (expval e' r)
expval (Let d e) r = expval e (declenv d r r)

declenv :: Decl -> Env -> Env -> Env
declenv (Decl x e) r' r = update r x (expval e r')

-- Initial environment
r0 :: Env
r0 = none

-- Evaluation function
eval e = expval (parse e) r0
