-- Section 4.3
-- Expressions with Declaration lists

type Env = Assoc Ide Int

expval :: Expr -> Env -> Int
expval (Num n) r = numval n
expval (Var x) r = lookup r x
expval (Bexpr o e e') r = binopr o (expval e r) (expval e' r)
--expval (Let ds e) r = expval e r''
--		      where
--		      r'' = foldl declenv' r ds
--		      declenv' r' d = declenv d r r'
expval (Let ds e) r = expval e (recdecl ds r)

declenv :: Decl -> Env -> Env -> Env
declenv (Decl x e) r' r = update r x (expval e r')

recdecl :: [Decl] -> Env -> Env
recdecl ds r = r''
	       where
	       r'' = foldl declenv' r ds
	       declenv' r' d = declenv d r'' r'

-- Initial environment
r0 :: Env
r0 = none

-- Evaluation function
eval e = expval (parse e) r0
