-- Section 5.1
-- Fig.5.2: Assignment and sequencing commands

data Val = V_Int Int
type Store = Assoc Ide Val

cmdexec :: Cmd -> Store -> Store
cmdexec (Assign x e) s = update s x (expval e s)
cmdexec (Seq cs) s = foldl (flip cmdexec) s cs

expval :: Expr -> Store -> Val
expval (Num n) s = V_Int (numval n)
expval (Var x) s = lookup s x
expval (Bexpr o e e') s = V_Int (binopr o v v')
			  where
			  V_Int v = expval e s
			  V_Int v' = expval e' s


-- Initial store
t0 :: Store
t0 = none

-- Execution function
exec c = lookup (cmdexec (parse c) t0) "result"
