-- Section 7.2 Type checking

data Typ = Typ_Int | Typ_Bool | Typ_Wrong
type Typ_Env = Assoc Ide Typ

exptyp :: Expr -> Typ_Env -> Typ
exptyp (Num n) r = Typ_Int
exptyp (Var x) r = lookup r x
exptyp (Let ds e) r = exptyp e (foldl declenv' r ds)
	where
	declenv' r' (Decl x e) = update r' x (exptyp e r)
exptyp (Bexpr o e e') r
	= bintyp (exptyp e r) (exptyp e' r)
	where
	bintyp Typ_Int Typ_Int = Typ_Int
	bintyp _ _ = Typ_Wrong
exptyp (Rexpr o e e') r
	= reltyp (exptyp e r) (exptyp e' r)
	where
	reltyp Typ_Int Typ_Int = Typ_Bool
	reltyp _ _ = Typ_Wrong
exptyp (If e (e',e'')) r
	= iftyp (exptyp e r) (exptyp e' r) (exptyp e'' r)
	where
	iftyp Typ_Bool Typ_Int Typ_Int = Typ_Int
	iftyp Typ_Bool Typ_Bool Typ_Bool = Typ_Bool
	iftyp _ _ _ = Typ_Wrong

-- Initial environment
r0 :: Typ_Env
r0 = assoc Typ_Wrong

-- Typing function
typ :: [Char] -> Typ
typ e = exptyp (parse e) r0
