-- Section 9.4
-- Stack machine with transfer instructions

-- Initial Stack
st0 :: Stack
st0 = []

-- Initial Store
t0 :: Store
t0 = none

-- Execute instructions
exec :: Code -> State -> State
exec (Stop:_) s = s
exec (PushNum n:is) (st,t) = exec is (V_Int n:st, t)
exec (PushVar x:is) (st,t) = exec is (lookup t x : st, t)
exec (PopVar x:is) (v:st,t) = exec is (st, update t x v)
exec (Bopr o:is) (V_Int v':V_Int v:st,t) = exec is (V_Int(binopr o v v'):st, t)
exec (Ropr o:is) (V_Int v':V_Int v:st,t) = exec is (V_Bool(relopr o v v'):st, t)
exec (Jump is':_) (st,t) = exec is' (st,t)
exec (JumpFalse is':is) (V_Bool v:st,t)
	| v = exec is (st,t)
	| otherwise = exec is' (st,t)

-- Run code
runcode is = lookup (snd (exec is (st0,t0))) "result"

-- Example program
example =
  "begin n:=3; f:=1; while n>0 do begin f:=n*f; n:=n-1 end; result:=f end"

